// Number2English.cpp: implementation of the CNumber2English class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "N2E.h"
#include "Number2English.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNumber2English::CNumber2English()
{
	InitNumberArrays();
}

CNumber2English::~CNumber2English()
{

}

CString CNumber2English::n2e(int number)
{
	// This function takes an integer as an argument, and returns the english equivilent
	CString result;				// The return value
	int     list[10];
	float	test;				// Test for length
	int		c = 0;				// A counter
	int		place[10] = {0,0,0,0,0,0,0,0,0,0};
	CString	firstpart, lastpart, midpart, mid2part, choice;

	if (number == 0)
		return "Zero";

	while (number) {
		list[c] = number % 10;
		number /= 10;
		c++;
	}
	
	test = (float) c / 3;
	
	if (test < 1)
		// Number is 99 or less
		return (MakeNumber(c, list));
	else if (test == 1) {
		// Number is 100 through 999
		place[0] = list[0];
		place[1] = list[1];
		lastpart  = MakeNumber(2, place);
		firstpart = english[list[2]];
		return (firstpart + " Hundred " + lastpart);
	} else if (test < 2) {
		// Number is 1,000 through 99,999
		if (c == 4)
			firstpart = english[list[3]];
		else {
			place[0] = list[3];
			place[1] = list[4];
			firstpart = MakeNumber(2, place);
		}
		place[0] = list[0];
		place[1] = list[1];
		lastpart = MakeNumber(2, place);
		midpart  = english[list[2]];
		if (midpart == "")
			choice = "";
		else
			choice = " Hundred ";
		return (firstpart + " Thousand " + midpart + choice + lastpart);
	} else if (test ==2) {
		// Number is 100,000 throug 999,999
		firstpart = english[list[5]] + " Hundred ";
		place[0] = list[3];
		place[1] = list[4];
		midpart  = MakeNumber(2, place);
		mid2part = english[list[2]];
		if (mid2part == "")
			choice = "";
		else
			choice = " Hundred ";
		place[0] = list[0];
		place[1] = list[1];
		lastpart  = MakeNumber(2, place);
		return (firstpart + midpart + " Thousand " + mid2part + choice + lastpart);
	}
	
	return ("Number is out of range!");
}

CString CNumber2English::MakeNumber(int n, int list[])
{
	CString word, word1, word2, dash;

	if (n == 1)
		// Single digit was passed, return the "english"
		return (english[list[0]]);
	else if (n == 2) {
		if (list[1] == 1)
			return (teen[list[0]]);
		else {
			word1 = ty[list[1]];
			word2 = english[list[0]];
			if (word2 == "")
				dash = "";
			else
				dash = "-";
			word = word1 + dash + word2;
			return word;
		}
	}

	// If we fall through, return -1
	return -1;
}

void CNumber2English::InitNumberArrays()
{
	// Initialize the number arrays

	english[0] = "";
	english[1] = "One";
	english[2] = "Two";
	english[3] = "Three";
	english[4] = "Four";
	english[5] = "Five";
	english[6] = "Six";
	english[7] = "Seven";
	english[8] = "Eight";
	english[9] = "Nine";

	teen[0]     = "Ten";
	teen[1]     = "Eleven";
	teen[2]     = "Twelve";
	teen[3]     = "Thirteen";
	teen[4]     = "Fourteen";
	teen[5]     = "Fifteen";
	teen[6]     = "Sixteen";
	teen[7]     = "Seventeen";
	teen[8]     = "Eighteen";
	teen[9]     = "Nineteen";

	ty[0]		= "";
	ty[1]		= "";
	ty[2]		= "Twenty";
	ty[3]		= "Thirty";
	ty[4]		= "Forty";
	ty[5]		= "Fifty";
	ty[6]		= "Sixty";
	ty[7]		= "Seventy";
	ty[8]		= "Eighty";
	ty[9]		= "Ninety";
}
